Vislt - Bug # 1291: Error with double precison MIR when reading Silo file
Subject: Error with double precison MIR when reading Silo file

Description: Cyrus has a reproducer.

The problem appears when there are mixed zones in a material region. Instead of the proper result garbage
values appear (1e7, instead of ~10). These values stride though out the mesh - they aren't near the actual
mixed cells.

The error does not occur when force single is on and appeared with the release of Vislt 2.5.

History

01/08/2013 07:17 pm - Cyrus Harrison

We think the issue is due to the fact that the avtmaterial / species data structs are still single precision, if so we need to do a conversion to float.

While double prec isn't likely necessary for vol fracs and spec mass fracs, it may be useful for mix vars, so we may actually need to provide full double

prec support in the future.

01/08/2013 07:17 pm - Cyrus Harrison

- Assigned to set to Cyrus Harrison
01/09/2013 01:37 pm - Cyrus Harrison
| looked at the Silo DB plugin: ConvertToFloat appears to be used when we create avt material, avt mixed var, and avt species instances. So

something else may still be wrong.

01/10/2013 06:35 pm - Cyrus Harrison

More info:

It looks like the mixvar is actually float array, even though the datatype is double for the standard var section.

It could be that:

*Silo expect this data to be float, or coerces it to be even if force single is off.

*The sim code incorrectly wrote the data as a float

01/15/2013 12:04 am - Mark Miller

| looked at an example file that demonstrates the problem with Vislt 2.5.2 on rzalastor. Although | do see some oddities in behavior between force
single on/off cases, | don't see the kinds of corruption described here.

The example file | was given definitely has double data for both the main variable as well as the mixed values. | confirmed this with h5ls.

The file | was given also has some oddities in volume fraction data. Two materials are present and mixed values are such that material A's value is 1

and material B's value is 0.001. The 'average' variable value also varies between 0.001 and 1.

02/26/2013 1/2




With force single off (the default Silo plugin read options setting), when | turn off material B, | get correct shapes for MIR'd zones but PC color
displayed is the average value, not the material specific values which in this case would be 1 everywhere (or red). With force single on, | get correct

shapes for MIR'd zones and | get material specific values everywhere (so all red).

01/15/2013 12:18 am - Mark Miller

| am seeing this on current trunk too.

| have inspected the mixed variable values in the Silo plugin just before we hand them to the avtMixedVariable constructor with and without force
single and in both cases, the values passed into the constructor are identical. Something is happening elsewhere, maybe with the volume fractions
themselves. Although, analysis with picks shows same volume fractions for 2 materials in both cases (0.001 and 1).

01/15/2013 12:11 pm - Eric Brugger
- Status changed from New to Pending
- Priority changed from Normal to Urgent

01/15/2013 01:03 pm - Mark Miller

- Assigned to changed from Cyrus Harrison to Mark Miller

01/15/2013 02:21 pm - Mark Miller
I've convinced myself that in either case, Silo is returning to the Vislt plugin the data values that it should and that the Vislt plugin is in turn handling

those values and passing them to Vislt as it should.

In the case that Force Single is on (the default), Vislt winds up getting float (single precision) for all of the following...
* material volume fractions
* variable 'average' values

* variable mixed values

In the case that Force Single is off, Vislt winds up getting...
* material volume fractions as float
* variable 'average' values as double

* variable mixed values as float

| ran with valgrind on the engine_ser and no memory faults were reported for either setting of Force Single.

01/15/2013 02:56 pm - Mark Miller
Ok, | have found the problem. There is a place in MIR that assumes the main variable array (e.g. the 'average' value array) is float. There is a
(float*)GetVoidPointer(0). Upon adjusting that logic, | can get both cases to display correctly. There is a broader question here and that is how to

handle all the different types that could be encountered here instead of an assumption of float values.

01/15/2013 04:25 pm - Mark Miller

- Status changed from Pending to Resolved

The problem is that there was some logic in MIR involved in _overwriting_ values in the main variable array that assumed the vtkDataArray was a

vtkFloatArray and that GetVoidPointer(0) could be casted to float* without issue.

| adjusted the loop to overwrite values to use arr->SetTuple() method instead.
